/**
* @file mc_control.c
*
* Copyright (c) 2005 Atmel.
*
* @brief {PIDٰ݂񋟂܂B
* ̌`:PID͔AϕAӖ܂B
* 4ނ̒p\łB:
* - JH
* - x
* - d(ٸ)
* - ʒu
* @version 1.0 (CVS revision : $Revision: 1.4 $)
* @date $Date: 2006/07/12 12:58:27 $
* @author $Author: raubree $
*****************************************************************************/
#include "config.h"
#include "config_motor.h"

#include "mc_control.h"
#include "mc_drv.h"
#include "mc_interface.h"

#include "mc_interface.h"

U8 duty_cycle = 0;					//!< vZPWMޭè قݒ肷Ұ
U8 BO_BF = SPEED_LOOP;				//!< `(OPEN_LOOP܂CLOSE_LOOP)`

/* xϐ */
S16 speed_error = 0;				//!< 덷vZ
S16 last_speed_error = 0;			//!< ŏI덷pϐ
S16 speed_integral = 0;
S16 speed_integ = 0;
S16 speed_proportional = 0;
S16 speed_derivative = 0;
S16 speed_der = 0;

/* dϐ */
S16 cur_error = 0;					//!< 덷vZ
S16 last_cur_error = 0;				//!< ŏI덷pϐ
S16 cur_integral = 0;
S16 cur_integ = 0;
S16 cur_proportional = 0;
S16 cur_derivative = 0;
S16 cur_der = 0;

/* ʒuϐ */
S16 pos_error = 0;					//!< 덷vZ
S16 last_pos_error = 0;				//!< ŏI덷pϐ
S16 pos_integral = 0;
S16 pos_integ = 0;
S16 pos_proportional = 0;
S16 pos_derivative = 0;
S16 pos_der = 0;

/************************************************************************************************************/
/*												x													*/
/************************************************************************************************************/
/**
* @brief xɎgpAxJԂ
* KvҰ: config_motor.hKp_speed, Ki_speed, Kd_speed, K_speed_scal
* Te(ms)ł̌ĂяoKv
* @return x̒lA8ޯĂłޭè 
*/
U8 mc_control_speed(U8 speed_cmd)
{
  U8 Duty = 0;
  S16 increment = 0;

  // 덷vZ
  speed_error = (S16)speed_cmd - mci_get_measured_speed();	// l-255 <=> 255

  // ፀvZ
  speed_proportional = (S16)Kp_speed * speed_error;

  // ϕvZ
  speed_integral = speed_integral + speed_error;

  if(speed_integral >  (S16)255) speed_integral =  255;
  if(speed_integral < (S16)-255) speed_integral = -255;

  speed_integ = (S16)Ki_speed * speed_integral;

  // vZ
/*  speed_derivative = (S16)speed_error - last_speed_error;

  if(speed_derivative >  (S16)255) speed_derivative =  255;
  if(speed_derivative < (S16)-255) speed_derivative = -255;

  speed_der = Kd_speed*speed_derivative;

  last_speed_error = speed_error;*/

  // ޭè ٌvZ
  increment = speed_proportional + speed_integ;
  //increment += speed_der;
  increment = increment >> K_speed_scal;
  increment = increment + Klin_speed;

  // ϐOa
  if(increment >= (S16)(240)) Duty = 240;
  else
  {
	if(increment <= (S16)(130)) Duty = 130;
	else Duty = (U8)(increment);
  }

  /* Vޭè "Duty Cycle"ԂB */
  return Duty;
}

/************************************************************************************************************/
/*												d													*/
/************************************************************************************************************/
/**
* @brief dɎgpAdJԂ
* KvҰ: config_motor.hKp_cur, Ki_cur, Kd_cur, K_cur_scal
* Te(ms)ł̌ĂяoKv
* @return d̒lA8ޯĂłޭè 
*/
U8 mc_control_current(U8 cur_cmd)
{
  U8 Duty = 0;
  S32 increment = 0;

  // 덷vZ
  cur_error = cur_cmd - (mci_get_measured_current());	// l-255 <=> 255

  // ፀvZ
  cur_proportional = Kp_cur*cur_error;

  // ϕvZ
  cur_integral = cur_integral + cur_error;

  if(cur_integral >  255) cur_integral =  255;
  if(cur_integral < -255) cur_integral = -255;

  cur_integ = Ki_cur*cur_integral;

  // vZ
  /*cur_derivative = cur_error - last_cur_error;

  if(cur_derivative >  255) cur_derivative =  255;
  if(cur_derivative < -255) cur_derivative = -255;

  cur_der = Kd_cur*cur_derivative;

  last_cur_error = cur_error;*/

  // ޭè ٌvZ
  increment = cur_proportional + cur_integ;
  //increment += cur_der;
  increment = increment >> K_cur_scal;

  // ϐOa
  if(increment >= (S16)(255)) Duty = 255;
  else
  {
	if(increment <= (S16)(0)) Duty =   0;
	else Duty = (U8)(increment);
  }

  // ޭè قԂ
  return Duty;
}

/************************************************************************************************************/
/*												ʒu													*/
/************************************************************************************************************/
/**
* @brief ʒuɎgpAʒuJԂ
* KvҰ: config_motor.hKp_cur, Ki_cur, Kd_cur, K_cur_scal
* Te(ms)ł̌ĂяoKv
* @return d̒lA8ޯĂłޭè 
*/
U8 mc_control_position(S32 Number_of_turns)
{
  U8 Duty = 0;
  S32 increment = 0;

  // 덷vZ
  pos_error =  Number_of_turns - mc_get_Num_Turn();

  // ፀvZ
  pos_proportional = Kp_pos*pos_error;

  // ϕvZ
  pos_integral = pos_integral + pos_error;

  if(pos_integral >  255) pos_integral =  255;
  if(pos_integral < -255) pos_integral = -255;

  pos_integ = Ki_pos * pos_integral;

  // vZ
  pos_derivative = pos_error - last_pos_error;

  if(pos_derivative >  255) pos_derivative =  255;
  if(pos_derivative < -255) pos_derivative = -255;

  pos_der = Kd_pos*pos_derivative;

  last_pos_error = pos_error;

  // ޭè ٌvZ
  increment = pos_proportional + pos_integ;
  increment += pos_der;
  increment = increment >> K_pos_scal;

  // ϐOa
  if(increment >= (S16)(0))
  {
    if(increment >= (S16)(100))Duty = 100;
    else Duty = (U8)(increment);
    mci_set_motor_direction(CW);
  }
  else
  {
    if(increment <= (S16)(-100)) Duty = 100;
    else Duty = (U8)(-increment);
    mci_set_motor_direction(CCW);
  }
  // ޭè قԂ
  return Duty;
}

/******************************************************************************/
/*								JԂ̑I							  */
/******************************************************************************/
/**
* @brief	xJn܂͒Ȃ
* @pre		Ȃ
* @post		VPWMޭè 
*/
void mc_regulation_loop()
{
  // 
  Set_EXT3();
  switch(BO_BF)
  {
	case OPEN_LOOP     : duty_cycle = mci_get_motor_speed();break;
	case SPEED_LOOP    : duty_cycle = mc_control_speed(mci_get_motor_speed());break;
	case CURRENT_LOOP  : duty_cycle = mc_control_current(mci_get_potentiometer_value());break;
	case POSITION_LOOP : duty_cycle = /*mc_control_speed(*/mc_control_position(mci_get_potentiometer_value())/*)*/;break;
	default : break;
  }
  // 
  Clear_EXT3();
}

/**
* @brief	JHJԂ`ݒ
* @pre		Ȃ
* @post		JHJԂݒ
*/
void mc_set_Open_Loop(){BO_BF = OPEN_LOOP;}

/**
* @brief	x`ݒ
* @pre		Ȃ
* @post		xJԂݒ
*/
void mc_set_Speed_Loop(){BO_BF = SPEED_LOOP;}

/**
* @brief	d`ݒ
* @pre		Ȃ
* @post		dJԂݒ
*/
void mc_set_Current_Loop(){BO_BF = CURRENT_LOOP;}

/**
* @brief	ʒu`ݒ
* @pre		Ȃ
* @post		ʒuJԂݒ
*/
void mc_set_Position_Loop(){BO_BF = POSITION_LOOP;}

/**
* @brief	ޭè َ擾
* @pre		Ȃ
* @post		ޭè ق擾
*/
U8 mc_get_Duty_Cycle()
{
  return duty_cycle;
}
