/**
* @file mc_lib.c
*
* Copyright (c) 2005 Atmel.
*
* @brief {͓d@Ɋւ鍂ʊ֐񋟂܂B
*
* @version 1.0 (CVS revision : $Revision: 1.3 $)
* @date $Date: 2006/07/12 12:58:27 $
* @author $Author: raubree $
*****************************************************************************/
#include "config.h"
#include "config_motor.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

void mc_ramp_up_init(void);

Bool mci_direction			= CW;			//!< d@ݒ肷邽߂̎gpғҰ
Bool mci_run_stop			= STOP;			//!< d@Jn܂͒~邽߂̎gpғҰ
U8 mci_cmd_speed			= 0;			//!< d@xݒ肷邽߂̎gpғҰ

U8 mci_measured_speed		= 0;			//!< d@x𓾂邽߂̓d@Ұ
U32 mci_measured_current	= 0;			//!< d@d𓾂邽߂̓d@Ұ
U8 mci_potentiometer_value	= 0;			//!< d@xݒ肷邽߂̓d@Ұ


/**
* @brief	d@̏Ԏ擾
* @param
* @pre		ʰ޳ƿĳ̏
* @post		d@sۂm܂B
*/
Bool mci_motor_is_running(void)
{
  return mci_run_stop;
}

/**
* @brief	۸яɎgp
* @param
* @post		ʰ޳ƿĳ̌`Ԑݒ
* @pre		Ȃ
*/
void mc_motor_init()
{
  mc_init_HW();
  mc_init_SW();

  mci_stop();
  mci_store_measured_speed(0);
}

/*
* @brief	xύX
* @pre		d@̏
* @post		x̐Vl
*/
void mci_set_motor_speed(U8 speed)
{
  mci_cmd_speed = speed;
}

/*
* @brief	x
* @pre		d@̏
* @post		xl擾
*/
U8 mci_get_motor_speed(void)
{
  return mci_cmd_speed;
}

/*
* @brief	ύX
* @pre		d@̏
* @post		V̒l
*/
void mci_set_motor_direction(U8 direction)
{
//  if ((mci_direction == CW) || (mci_direction == CCW)) mci_direction = direction;
  mci_direction = direction;
}

/*
* @brief	]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_forward(void)
{
  mci_direction = CW;
}

/*
* @brief	t]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_backward(void)
{
  mci_direction = CCW;
}

/*
* @brief	l擾
* @pre		d@̏
* @post		l擾
*/
/* U8 mci_get_motor_direction(void)
{
  return mci_direction;
} */

/**
 * @brief	xݒ(p)
 * @pre		Ȃ
 * @post	mc_measured_speed
*/
void mci_store_measured_speed(U8 measured_speed)
{
  mci_measured_speed = measured_speed;
}

/**
 * @brief	x
 * @return	x(8ޯ)lԂB
 * @pre		Ȃ
 * @post	Ȃ
*/
U8 mci_get_measured_speed(void)
{
  return mci_measured_speed;
}

/**
* @brief	d@d擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ12̌(8ޯĂ̓dl)擾
*/
U16 mci_get_measured_current(void)
{
/*  U16 value_to_return;
  value_to_return = mci_measured_current>>6;
  if (value_to_return > 994)
  {
    value_to_return = value_to_return - 994;
  }
  else
  {
    value_to_return = 994 - value_to_return;
  }
  return value_to_return;*/
  return mci_measured_current;
}

/**
* @brief	̂߂'mc_measured_current'ϐݒ
* @pre		Ȃ
* @post		currentl'mc_measured_current'ݒ
*/
void mci_store_measured_current(U16 current)
{
  mci_measured_current = ((63*mci_measured_current)+(64*current))>>6;
}

/**
* @brief	ϒRl擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ6̌(8ޯẲϒRl)擾
*/
U8 mci_get_potentiometer_value(void)
{
  return mci_potentiometer_value;
}

/**
* @brief	ϒRl'mc_potentiometer_value'ϐݒ
* @pre		A/Dϊv敔Jn
* @post		ϒRl'mc_potentiometer_value'ݒ
*/
void mci_store_potentiometer_value(U8 potentiometer)
{
  mci_potentiometer_value = potentiometer;
}

/**
* @brief	mci_run͗\ߒ`ꂽҰœd@𓮂܂B
* @param
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_run(void)
{
  mc_motor_init();						// d@̏Jn
  mci_run_stop = RUN;
  mci_set_motor_speed(DUTY_RAMP_UP);	/* グpxݒ */
  mc_set_Open_Loop();					/* `ݒ */
  mc_regulation_loop();					/* 1s */
  mc_ramp_up_init();
  PSC_Run();
}

void mci_stop(void)
{
  PSC_Stop();
  mci_run_stop  = STOP;
}


void mci_set_speed(U16 speed)
{
  mci_set_motor_speed((U8)speed);
}
